#pragma once
#include <iostream>
#include <algorithm>
#include <map>
#include <fstream>
#include <vector>
#include <cstdlib>
#include <iomanip>

class Product {
private:
	char number_warehouse[10];      
	char code[10];     
	char name[10];
	char date_day[10];     
	char date_month[10];
	char date_year[10];
	char shelf_life[10];   
	char quantity[10];     
	char price[10];      
public:
	Product() = default; //!!! Конструктор по умолчанию и так создается автоматически.
	~Product() = default; //!!! Деструктор и так создается автоматически.

    //!!! Среди полей имеются указатели/массивы. Где контруктор копирования и оператор присваивания?

	void NewProduct();

	int date_in_days();
	int Output_number_warehouse();
	int Output_code();
	std::string Output_name();
	std::vector<int> Output_date();
	int Output_shelf_life();
	int Output_quantity();
	int Output_price();
};

class List_Product {
private:
	std::map<size_t, Product*> map_Product;
	size_t size = 0;
public:
	List_Product() = default;
	Product** operator[](size_t num);

	std::map<size_t, Product*>& Output_map_Product();

	void Output_from_file(std::ifstream& file);
	void Output_in_file(std::ofstream& file);

	List_Product Search_by_warehouse_number();
	List_Product Search_by_product_code();
	List_Product Search_by_date_of_receipt();
	List_Product Search_by_shelf_life();

};

//!!! Вообще не понял, как так код пофайлам рабивать можно?
//!!! Что тут делают эти объявления? Создавайте тогда Functions.h

void Primary_input(const std::string& filename);
void Add_to_file(const std::string& filename);
void Delete_an_record(const std::string& filename);
void Replace_record(const std::string& filename);
void Search_for_records(const std::string& filename);
void Convert_to_a_text_file(const std::string& filename);